/***************************************************************************
    File        : WhiteningFilter.h
    Description : Generates a WhiteningFilter filter
 ---------------------------------------------------------------------------
    Begin       : Mon Sep 3 2001
    Author(s)   : Roberto Grosso
 ***************************************************************************/

#ifndef __WHITENING_FILTER_H
#define __WHITENING_FILTER_H

// Libs
#include <vector>

// Project files
#include "Types.h"
#include "Singleton.h"
#include "Numeric.h"
#include "PowerSpectrum.h"
#include "RunningMedian.h"
#include "WindowFilterDesign.h"

namespace gwd {

  class WhiteningFilter {
  public:
    WhiteningFilter() {}
    ~WhiteningFilter() {}

    // Methods
    bool ComputeFilter(const unsigned int fOrder,const unsigned int noOfFreq,const unsigned int rmWindow,
                       Vector& signal,Vector& filter);

  private:

  };

} // namespace gwd
#endif // __WHITENING_FILTER_H

