//
//  Function FOM3unknown:  Helper function for PulsarMon.  Reads an 
//
///////////////////////////////////////////////////////////////////////////
#ifndef FOM3unknown_HH
#define FOM3unknown_HH

#include "FSpectrum.hh"
#include <fstream>
#include <iostream>

// This segment of code assumes that the FSpectrum object has already been
// PSDed and calibrated.  This function inverts the FSpectrum and divides
// by f^(7/3).

/** Helper function for SenseMonitor.  
  * Assigns to out the FSpectrum for $(f^{7/3} \times (psd * psd_2))^{-1}$.
  * @memo Computes integrand for range estimate integral.
  * @param out Output power spectrum.
  * @param psd Input power spectrum.
  */ 
void FOM3unknown(FSpectrum& out, FSpectrum& psd);

#endif     //  FOM3unknown_HH
