//
//    Trigger result class implementation.
//
#include "TrigRslt.hh"
#include "TrigRaw.hh"
#include "TrigProc.hh"
#include "Interval.hh"

using namespace trig;
using namespace std;

//======================================  Data constructor
TrigRslt::TrigRslt(const char* ID, const char* SubID, 
		   index_type nData, const param_type *DList) 
  : TrigBase(ID, SubID)
{
    if (nData > 0 && DList) {
        setData((const char*)DList, nData*sizeof(param_type));
    } else if (nData) {
        zeroResult(0, nData*sizeof(param_type));
    }
}

TrigRslt::TrigRslt(const TrigRslt& x) 
  : TrigBase(x)
{}

//======================================  Destructor
TrigRslt::~TrigRslt(void) {
}
